// jshint maxerr:1000
/* ---------------------------------------------------------------------------------------------------------

    SCRIBBLEMAKES THEME - GLASSPANE MANA V1.0
    -----------------------------------------
    Last updated: 9th August 2023
    
    Welcome to the Glasspane Mana theme! To read more about it, follow the instructions in the 'more 
      information' link (https://scribblemakes.com/code/development#scTheme_GlasspaneMana).
      
    --------------------------------------
    
    FEATURES INCLUDED WITH THIS THEME'S JAVASCRIPT:
      -> 
    
    --------------------------------------
    
    /‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\  Looking for more tutorials, widgets, and plugins?       /‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾\  
   ｜  ❮‾ |\  /|  / ⎡‾‾  ｜  Get them at my personal website or LHClubhouse room   ｜  ❮‾ |\  /|  / ⎡‾‾  ｜
   ｜  _❯ | \/ | /  ⎣__  ｜   https://scribblemakes.com/code                       ｜  _❯ | \/ | /  ⎣__  ｜  
    \___________________/    https://lordhorse.neocities.org/office/home           \____________________/ 
        
    --------------------------------------
    
    For more information on this script:
     https://scribblemakes.com/code/development#scTheme_GlasspaneMana
      
--------------------------------------------------------------------------------------------------------- */

// FILL IN ANY VARIABLES BELOW IF YOU WANT TO CHANGE THEM FROM THE DEFAULT

var sc_setting_username = "GUEST";  // Replace with the name you want to appear on the site
var sc_setting_systemname = "TEST COMPUTER";  // Replace with what you want to call your 'computer'
var sc_setting_localename = "Australia";  // Replace with where you want to say the computer is

var sc_setting_helpText = "Help"; // What title to give help panels
var sc_setting_helpIcon = "imgs/icon_help.png"; // URL for the help image, can be left empty to have none
var sc_setting_missingIcon = "imgs/favicon.png"; // URL for the desktop image if a window has no img tag

var sc_setting_shutDownLink = "https://scribblemakes.com/code";  // Where user links to when shutting down

var sc_setting_clockActive = true;  // Adds a clock to the taskbar if true

var sc_setting_notepadActive = true;  // Adds a notepad app to the start menu (NOTE: ONLY SAVES LOCALLY, WHAT YOU WRITE IN THERE WILL NOT BE VISIBLE TO OTHERS)
  var sc_setting_notepadIcon = "imgs/icon_notepad.png"; // Icon for the notepad app
  
var sc_setting_moreApps = true; // Adds link in start menu to find more apps to add to the theme



// ---------------------------------------------------------------------------------------------------------
// ---------------------- DO NOT EDIT PAST THIS POINT UNLESS PROFICIENT IN JAVASCRIPT ----------------------
// ---------------------------------------------------------------------------------------------------------

// ----------------------------------------------------------------------
// --------------------- APPEND TASKBAR STYLE SHEET --------------------- 
// ----------------------------------------------------------------------
var sc_taskbar_startingTabAmount = 4;
if (sc_setting_clockActive) {
  sc_taskbar_startingTabAmount = 3;
}

var sc_taskbarCSS = document.createElement("style");
sc_taskbarCSS.innerText = 
  `/* Start hiding taskbar tabs if the screen gets too small */
    #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 11) + `) ~ a {display: none;}
    @media only screen and (max-width: 1200px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 10) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 1100px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 9) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 1000px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 8) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 900px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 7) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 800px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 5) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 700px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 3) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 600px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + (sc_taskbar_startingTabAmount + 1) + `) ~ a {display: none;}
    }
    @media only screen and (max-width: 500px) {
      #sc_taskbar_linkHolder_table a:nth-child(` + sc_taskbar_startingTabAmount + `) ~ a {display: none;}
    }
  `;
document.head.appendChild(sc_taskbarCSS);


// ---------------------------------------------------------------------
// --------------------------- Z-INDEX FIXER --------------------------- 
// ---------------------------------------------------------------------
var sc_zIndexTracker = 0;

function sc_ZIndexFix(sc_windowId) {
  sc_zIndexTracker++;
  
  let sc_windowHolder = document.getElementById(sc_windowId);
  sc_windowHolder.style.zIndex = sc_zIndexTracker;
  if (sc_windowHolder.getElementsByClassName("tabActive")[0]) {
    sc_windowHolder.getElementsByClassName("tabActive")[0].style.zIndex = sc_zIndexTracker + 1;
  }
  document.getElementById('sc_taskbar').style.zIndex = sc_zIndexTracker + 2;
}


// ----------------------------------------------------------------------
// ---------------------- CREATE TASKBAR & DESKTOP ---------------------- 
// ----------------------------------------------------------------------
var sc_taskbar = document.createElement("footer");
sc_taskbar.id = "sc_taskbar";
document.body.appendChild(sc_taskbar);

// Add start menu
let sc_taskbar_startMenu = document.createElement("div");
sc_taskbar.appendChild(sc_taskbar_startMenu);
sc_taskbar_startMenu.id = "sc_taskbar_startMenu";
  // Add header to start menu
  let sc_taskbar_startMenu_header = document.createElement("header");
  sc_taskbar_startMenu.appendChild(sc_taskbar_startMenu_header);
  sc_taskbar_startMenu_header.innerText = sc_setting_username;
  // Add columns to start menu
  let sc_taskbar_startMenu_leftColumn = document.createElement("nav");
  sc_taskbar_startMenu.appendChild(sc_taskbar_startMenu_leftColumn);
  sc_taskbar_startMenu_leftColumn.id = "sc_taskbar_startMenu_leftColumn";
  let sc_taskbar_startMenu_rightColumn = document.createElement("nav");
  sc_taskbar_startMenu.appendChild(sc_taskbar_startMenu_rightColumn);
  sc_taskbar_startMenu_rightColumn.id = "sc_taskbar_startMenu_rightColumn";
  // Add footer to start menu
  let sc_taskbar_startMenu_footer = document.createElement("footer");
  sc_taskbar_startMenu.appendChild(sc_taskbar_startMenu_footer);
    // Add footer Turn Off Computer button
    let sc_taskbar_startMenu_footerQuit = document.createElement("a");
    sc_taskbar_startMenu_footer.appendChild(sc_taskbar_startMenu_footerQuit);
    sc_taskbar_startMenu_footerQuit.classList.add("buttonRed");
    sc_taskbar_startMenu_footerQuit.classList.add("buttonShutDown");
    sc_taskbar_startMenu_footerQuit.href = sc_setting_shutDownLink;
    let sc_taskbar_startMenu_footerQuitText = document.createElement("span");
    sc_taskbar_startMenu_footer.appendChild(sc_taskbar_startMenu_footerQuitText);
    sc_taskbar_startMenu_footerQuitText.innerText = "Turn Off Computer";

// Add start button
let sc_taskbar_startButton = document.createElement("button");
sc_taskbar.appendChild(sc_taskbar_startButton);
sc_taskbar_startButton.addEventListener("click", sc_OpenStart);
sc_taskbar_startButton.addEventListener("mousedown", sc_IgnoreStartMenu);

// Add link holder for the center
let sc_taskbar_linkHolder = document.createElement("div");
sc_taskbar.appendChild(sc_taskbar_linkHolder);
sc_taskbar_linkHolder.id = "sc_taskbar_linkHolder";

// Add link container to make sure it stays the right size
let sc_taskbar_linkHolder_container = document.createElement("div");
sc_taskbar_linkHolder.appendChild(sc_taskbar_linkHolder_container);
sc_taskbar_linkHolder_container.style.maxHeight = "2.25em";
sc_taskbar_linkHolder_container.style.maxwidth = "100%";
sc_taskbar_linkHolder_container.style.overflow = "hidden";
  // Add table element inside the link container
  let sc_taskbar_linkHolder_table = document.createElement("div");
  sc_taskbar_linkHolder_container.appendChild(sc_taskbar_linkHolder_table);
  sc_taskbar_linkHolder_table.id = "sc_taskbar_linkHolder_table";
    // Give that table an empty element to allow links to spread out
    let sc_taskbar_linkHolder_tableEmpty = document.createElement("div");
    sc_taskbar_linkHolder_table.appendChild(sc_taskbar_linkHolder_tableEmpty);
    sc_taskbar_linkHolder_tableEmpty.innerText = "E";
    sc_taskbar_linkHolder_tableEmpty.style.color = "transparent";
    sc_taskbar_linkHolder_tableEmpty.style.display = "table-cell";


// Add desktop space
let sc_desktop = document.createElement("div");
sc_desktop.id = "sc_desktop";
document.body.appendChild(sc_desktop);


// ---------------------------------------------------------------------
// --------------------- START MENU OPEN AND CLOSE --------------------- 
// ---------------------------------------------------------------------
var sc_clickedStartMenu = false;

// Opens start menu
function sc_OpenStart() {
  let sc_startmenu = document.getElementById("sc_taskbar_startMenu");
  if (sc_startmenu.style.display == "block") {
    sc_startmenu.style.display = "none";
    window.removeEventListener("mousedown", sc_HideStartMenu);
    sc_startmenu.removeEventListener("mousedown", sc_IgnoreStartMenu);
  } else {
    setTimeout(function() {
      window.addEventListener("mousedown", sc_HideStartMenu);
      sc_startmenu.addEventListener("mousedown", sc_IgnoreStartMenu);
      clickedStartMenu = false;
    }, 10);
    sc_startmenu.style.display = "block";
  }
}

// Hides start menu
function sc_HideStartMenu() {
  setTimeout(function() {
      if (sc_clickedStartMenu) {
        sc_clickedStartMenu = false;
      } else {
        document.getElementById("sc_taskbar_startMenu").style.display = "none";
        document.getElementById("sc_taskbar_startMenu").removeEventListener("mousedown", sc_IgnoreStartMenu);
        window.removeEventListener("mousedown", sc_HideStartMenu);
      }
  }, 10);
}

// Stops hide start menu from running
function sc_IgnoreStartMenu() {
  sc_clickedStartMenu = true;
}


// -----------------------------------------------------------------------
// -------------------------- CREATE EXTRA APPS -------------------------- 
// -----------------------------------------------------------------------
// Notepad app
if (sc_setting_notepadActive) {
  let sc_windowApp_notepad = document.createElement("section");
  document.body.appendChild(sc_windowApp_notepad);
  sc_windowApp_notepad.id = "sc_windowApp_notepad";
  sc_windowApp_notepad.title = "Notepad";
  sc_windowApp_notepad.classList.add("noDesktop");
  sc_windowApp_notepad.innerHTML = 
    `
    <img src="` + sc_setting_notepadIcon + `">
      <div style="padding:0;">
      <textarea style="resize:none; margin:0; border-width:0; width:100%; height:100%;" id="sc_windowApp_notepad_textarea" name="` + document.title + ` notepad" placeholder="Enter your notes here..."></textarea>
      </div>
      <footer>
        <a onclick="sc_CloseWindow('sc_windowApp_notepad')">Close</a>
        <a onclick="sc_windowApp_SaveNotes('sc_windowApp_notepad_textarea')">Save</a>
      </footer>
    `;
  if ("sc_windowApp_notepad_textarea" in localStorage) {
    document.getElementById("sc_windowApp_notepad_textarea").value = localStorage.getItem("sc_windowApp_notepad_textarea");
  }
}
function sc_windowApp_SaveNotes(sc_notepadContent) {
  localStorage.setItem("sc_windowApp_notepad_textarea", document.getElementById(sc_notepadContent).value);
  alert("Notepad saved to your browser, view here on " + window.location.href);
}


// Calculator app
/*if (sc_setting_calcActive) {
  let sc_windowApp_calculator = document.createElement("section");
  document.body.appendChild(sc_windowApp_calculator);
  sc_windowApp_calculator.id = "sc_windowApp_calculator";
  sc_windowApp_calculator.title = "Calculator";
  sc_windowApp_calculator.classList.add("noDesktop");
  sc_windowApp_calculator.style.resize = "none";
  sc_windowApp_calculator.innerHTML = 
    `
    <img src="` + sc_setting_calcIcon + `">
      <div>
        <span id="sc_windowApp_calculator_Screen" class="indentBox">TEST</span>
      </div>
      <footer>
        <a onclick="sc_CloseWindow('sc_windowApp_calculator')">Close</a>
      </footer>
    `;
}*/

// Add details and information window
let sc_windows_systemDetails = document.createElement("section");
document.body.appendChild(sc_windows_systemDetails);
sc_windows_systemDetails.id = "sc_windows_systemDetails";
sc_windows_systemDetails.title = "System Summary";
sc_windows_systemDetails.style.resize = "none";
sc_windows_systemDetails.classList.add("noDesktop");
sc_windows_systemDetails.innerHTML =
  `
    <img src="` + sc_setting_helpIcon + `">
    <div>
      <table>
        <tr>
          <td>OS Name</td>
          <td>Glasspane Mana</td>
        </tr>
        <tr>
          <td>Version</td>
          <td>V1.0 - INITIAL BUILD</td>
        </tr>
        <tr>
          <td>OS Manufacturer</td>
          <td>Scribblemakes</td>
        </tr>
        <tr>
          <td>System Name</td>
          <td>` + sc_setting_systemname + `</td>
        </tr>
        <tr>
          <td>Locale</td>
          <td>` + sc_setting_localename + `</td>
        </tr>
        <tr>
          <td>User Name</td>
          <td>` + sc_setting_username + `</td>
        </tr>
      </table>
    </div>
    <footer>
      <a onclick="sc_CloseWindow('sc_windows_systemDetails')">Close</a>
      <a href="https://scribblemakes.com/code">Find More</a>
    </footer>
  `;


// ----------------------------------------------------------------------
// --------------------------- CREATE WINDOWS --------------------------- 
// ----------------------------------------------------------------------
const sc_windows = document.querySelectorAll("body > section"); // Collect windows

for (sc_i = 0; sc_i < sc_windows.length; sc_i++) {  // Apply universal settings to all
  let sc_window_isHelp = false; // Sets if the window is for a help box
  
  // Make window focusable 
  sc_windows[sc_i].tabIndex = 0;

  // Add header to windows
  let sc_windows_header = document.createElement("header");
  sc_windows[sc_i].appendChild(sc_windows_header);
  
    // Add text to header
    let sc_windows_title = sc_windows[sc_i].title;
    sc_windows[sc_i].title = "";  // Stop text from popping up when hovering on window
    if (sc_windows_title == "") { // If window has no title
      sc_windows_title = sc_windows[sc_i].id;
      if (sc_windows_title == "") { // If window has no id, making it a help box
        sc_windows[sc_i].id = sc_windows[sc_i-1].id + "Help"; // Set help box id
        sc_windows_title = sc_setting_helpText;
        sc_window_isHelp = true;
      }
    }
    let sc_windows_titleSpan = document.createElement("span");
    sc_windows_titleSpan.innerText = sc_windows_title;
    sc_windows_header.appendChild(sc_windows_titleSpan);
    
    // Add image to header
    if (sc_windows[sc_i].querySelectorAll("img:first-child")[0]) {  // Check if window has an icon
      let sc_windows_icon = sc_windows[sc_i].querySelectorAll("img:first-child")[0];
      sc_windows_icon.alt = sc_windows_title + " icon"; // Add to alt text
      sc_windows_header.insertBefore(sc_windows_icon, sc_windows_header.children[0]);
    } else if (sc_window_isHelp) {  // Add help image if help box
      let sc_windows_icon = document.createElement('img');
      sc_windows_icon.src = sc_setting_helpIcon;
      sc_windows_icon.alt = sc_windows_title + " icon"; // Add to alt text
      sc_windows_header.insertBefore(sc_windows_icon, sc_windows_header.children[0]);
    }
    
    // Add header buttons
    if (sc_window_isHelp) { // Append help button to previous window
      let sc_windows_helpButton = document.createElement("a");
      sc_windows[sc_i-1].querySelectorAll("header")[0].appendChild(sc_windows_helpButton);
      sc_windows_helpButton.classList.add("buttonHelp");
      sc_windows_helpButton.addEventListener("click", function() {
        sc_OpenWindow(this.parentNode.parentNode.id + "Help");
      });
    }
    // Add close window button
    let sc_windows_closeButton = document.createElement("a");
    sc_windows_header.appendChild(sc_windows_closeButton);
    sc_windows_closeButton.classList.add("buttonRed");
    sc_windows_closeButton.classList.add("buttonClose");
    sc_windows_closeButton.addEventListener("click", function() {
      sc_CloseWindow(this.parentNode.parentNode.id);
    });
    // Add Minimise button
    let sc_windows_minButton = document.createElement("a");
    sc_windows_header.appendChild(sc_windows_minButton);
    sc_windows_minButton.classList.add("buttonMin");
    sc_windows_minButton.addEventListener("click", function() {
      sc_MinimiseToggle(this.parentNode.parentNode.id);
    });
    
    // Fix title overflow if help button is present
    if (sc_window_isHelp) {
      if (sc_windows[sc_i-1].querySelectorAll("header span")[0]) {
        sc_windows[sc_i-1].querySelectorAll("header span")[0].style.maxWidth = "calc(100% - 9em)";
      } else {
        sc_windows[sc_i-1].querySelectorAll("header span")[0].style.maxWidth = "calc(100% - 7em)";
      }
    } else if (sc_windows[sc_i].querySelectorAll("header img")[0]) {
      sc_windows[sc_i].querySelectorAll("header span")[0].style.maxWidth = "calc(100% - 7em)";
    }
    
    // Give help window a close button in the footer
    if (sc_window_isHelp) {
      let sc_windows_footer = document.createElement("footer");
      sc_windows[sc_i].appendChild(sc_windows_footer);
      let sc_windows_footerClose = document.createElement("a");
      sc_windows_footer.appendChild(sc_windows_footerClose);
      sc_windows_footerClose.innerText = "Close";
      sc_windows_footerClose.addEventListener("click", function() {
        sc_CloseWindow(this.parentNode.parentNode.id);
      });
    }
    
    // Set up open tabs if window has a nav section
    sc_windows[sc_i].querySelectorAll("section > div")[0].style.display = "block";  // Show first div box
    if (sc_windows[sc_i].querySelectorAll("nav")[0]) {  // Check that nav exists and if it has tabs
      let sc_windows_nav = sc_windows[sc_i].querySelectorAll("nav")[0];
      if (sc_windows_nav.hasChildNodes()){
        for (sc_ii = 0; sc_ii < sc_windows_nav.children.length; sc_ii++) {  // Assign onclicks to tabs
          if (!sc_windows_nav.children[sc_ii].href && !sc_windows_nav.children[sc_ii].onclick) {
            sc_windows_nav.children[sc_ii].addEventListener("click", function() {
              if (!this.classList.contains("tabActive")) {
                sc_OpenTab(this.parentNode.parentNode.id, String(this.classList));
              }
            });
          }
        }
        sc_windows_nav.children[0].classList.add("tabActive");  // Give first node the active class
      }
    } else {  // If window doesn't have a nav section
      for (sc_ii = 0; sc_ii < sc_windows[sc_i].querySelectorAll("section > div").length; sc_ii++) {
        sc_windows[sc_i].querySelectorAll("section > div")[sc_ii].style.top = "calc(2.5em + 6px)";
        sc_windows[sc_i].classList.add("sc_section_noFooter");
      }
    }
    
    // Set up main bodies of the window
    if (!sc_windows[sc_i].querySelectorAll("footer")[0]) {  // Change height if footer is missing
      sc_windows[sc_i].classList.add("sc_section_noHeader");
      if (sc_windows[sc_i].querySelectorAll("section > div")[0]) {  // Make sure it has divs
        for (sc_ii = 0; sc_ii < sc_windows[sc_i].querySelectorAll("section > div").length; sc_ii++) {
          sc_windows[sc_i].querySelectorAll("section > div")[sc_ii].style.bottom = "1em";
        }
      }
    }
    
    // Add window icon to the background if it's not a help window OR no display class
    if (!sc_window_isHelp && !sc_windows[sc_i].classList.contains("noDesktop")) {
      let sc_windows_desktopHolder = document.createElement("div");
      sc_windows_desktopHolder.id = "sc_desktopIcon_" + sc_windows[sc_i].id;
      sc_windows_desktopHolder.tabIndex = 0;
      sc_windows_desktopHolder.addEventListener("click", function() {
        this.focus();
      });
      sc_windows_desktopHolder.addEventListener("dblclick", function() {
        let sc_windows_programToOpen = document.getElementById(this.id.split("sc_desktopIcon_")[1]);
        if (sc_windows_programToOpen.style.display != "block") {  // Check if window is visible
          if (document.getElementById("sc_taskbarLink_" + sc_windows_programToOpen.id)) { // If min, max
            sc_MinimiseToggle(sc_windows_programToOpen.id);
          } else {  // If not open at all, open it
            sc_OpenWindow(sc_windows_programToOpen.id);
          }
        } else {  // If window is visible, bring it to the front
          sc_ZIndexFix(sc_windows_programToOpen.id);
        }
      });
      sc_desktop.appendChild(sc_windows_desktopHolder);
      
      // Add image to clickable
      let sc_windows_desktopIcon = document.createElement("img");
      if (sc_windows[sc_i].querySelectorAll("header img")[0]) {
        sc_windows_desktopIcon.src = sc_windows[sc_i].querySelectorAll("header img")[0].src;
      } else {
        sc_windows_desktopIcon.src = sc_setting_missingIcon;
      }
      sc_windows_desktopHolder.appendChild(sc_windows_desktopIcon);
      
      // Add text to clickable
      let sc_windows_desktopText = document.createElement("span");
      sc_windows_desktopHolder.appendChild(sc_windows_desktopText);
      if (sc_windows[sc_i].querySelectorAll("header span")[0]) {
        sc_windows_desktopText.innerText = sc_windows[sc_i].querySelectorAll("header span")[0].innerText;
      } else if (sc_windows[sc_i].title){
        sc_windows_desktopText.innerText = sc_windows[sc_i].title;
      } else {
        sc_windows_desktopText.innerText = sc_windows[sc_i].id;
      }
    }
    
    // Add window to programs section of the start menu
    let sc_taskbar_startMenu_pickedColumn = sc_taskbar_startMenu_rightColumn;
    if (sc_windows[sc_i].id.includes("sc_windowApp_")) {  // Checks if it's a system program
      // If system program, add it to the left column of the start menu
      sc_taskbar_startMenu_pickedColumn = sc_taskbar_startMenu_leftColumn;
    }
    if (!sc_window_isHelp && !sc_windows[sc_i].classList.contains("noStart")) {
      let sc_windows_startMenu_colLink = document.createElement("a");
      sc_taskbar_startMenu_pickedColumn.appendChild(sc_windows_startMenu_colLink);
      sc_windows_startMenu_colLink.id = "sc_taskbar_startMenu_rightLink_" + sc_windows[sc_i].id;
      // Add start menu text
      if (sc_windows[sc_i].querySelectorAll("header span")[0]) {
        sc_windows_startMenu_colLink.innerText = sc_windows[sc_i].querySelectorAll("header span")[0].innerText;
      } else if (sc_windows[sc_i].title){
        sc_windows_startMenu_colLink.innerText = sc_windows[sc_i].title;
      } else {
        sc_windows_startMenu_colLink.innerText = sc_windows[sc_i].id;
      }
      // Add image to start menu
      let sc_windows_startMenu_colLink_img = document.createElement("img");
      if (sc_windows[sc_i].querySelectorAll("header img")[0]) {
        sc_windows_startMenu_colLink_img.src = sc_windows[sc_i].querySelectorAll("header img")[0].src;
      } else {
        sc_windows_startMenu_colLink_img.src = sc_setting_missingIcon;
      }
      sc_windows_startMenu_colLink.appendChild(sc_windows_startMenu_colLink_img);
      // Add click events to start menu window links
      sc_windows_startMenu_colLink.addEventListener("click", function() {
        sc_HideStartMenu();
        let sc_windows_programToOpen = document.getElementById(this.id.split("sc_taskbar_startMenu_rightLink_")[1]);
        if (sc_windows_programToOpen.style.display != "block") {  // Check if window is visible
          if (document.getElementById("sc_taskbarLink_" + sc_windows_programToOpen.id)) { // If min, max
            sc_MinimiseToggle(sc_windows_programToOpen.id);
          } else {  // If not open at all, open it
            sc_OpenWindow(sc_windows_programToOpen.id);
          }
        } else {  // If window is visible, bring it to the front
          sc_ZIndexFix(sc_windows_programToOpen.id);
        }
      });
    }
    
    
    // Make starting window open and in the taskbar
    if (sc_i == 0) {
      sc_OpenWindow(sc_windows[sc_i].id);
    }
}

// Scribblemakes app notification
if (sc_setting_moreApps) {
  let sc_windowApp_findmore = document.createElement("span");
  sc_taskbar_startMenu_leftColumn.appendChild(sc_windowApp_findmore);
  sc_windowApp_findmore.innerHTML = "<a href='https://scribblemakes.com/code'><img src='https://scribblemakes.com/site_images/favicon.png'>More Apps</a>";
}

// ----------------------------------------------------------------------
// ------------------------ DRAGGABLE ELEMENT JS ------------------------ 
// ----------------------------------------------------------------------
// Edited from: https://www.w3schools.com/howto/howto_js_draggable.asp

// Give all windows a draggable element
for (sc_i = 0; sc_i < sc_windows.length; sc_i++) {
  sc_DragWindow(sc_windows[sc_i]);
}

function sc_DragWindow(sc_window_drag) {
  var sc_pos1 = 0, sc_pos2 = 0, sc_pos3 = 0, sc_pos4 = 0;
  sc_window_drag.querySelectorAll("header")[0].onmousedown = sc_DragMouseDown;
  // When window header is grabbed
  function sc_DragMouseDown(e) {
    sc_ZIndexFix(this.parentNode.id); // Fix overlapping
    
    this.style.cursor = "url('imgs/cursor_grabbing.png'), grabbing";
    e = e || window.event;
    e.preventDefault();
    // Get mouse cursor position at startup
    sc_pos3 = e.clientX;
    sc_pos4 = e.clientY;
    // When click is released
    document.onmouseup = sc_CloseDragElement;
    // When cursor moves
    document.onmousemove = sc_ElementDrag;
  }
  
  //When window is dragged around
  function sc_ElementDrag(e) {
    e = e || window.event;
    e.preventDefault();
    // Calculate new cursor position
    sc_pos1 = sc_pos3 - e.clientX;
    sc_pos2 = sc_pos4 - e.clientY;
    sc_pos3 = e.clientX;
    sc_pos4 = e.clientY;
    // Set window's new position
    sc_window_drag.style.top = (sc_window_drag.offsetTop - sc_pos2) + "px";
    sc_window_drag.style.left = (sc_window_drag.offsetLeft - sc_pos1) + "px";
    // Give height and width if they're not set
    if (sc_window_drag.style.height == "") {
      sc_window_drag.style.height = "500px";
      sc_window_drag.style.width = "400px";
    }
    // Reset it into bounds if it's offscreen
    if ((sc_window_drag.offsetTop - sc_pos2) < 0) {
      sc_window_drag.style.top = 0;
    } else if ((sc_window_drag.offsetTop - sc_pos2) > (window.innerHeight - sc_window_drag.style.height.split("px")[0])){
      sc_window_drag.style.top = (window.innerHeight - sc_window_drag.style.height.split("px")[0]) + "px";
    }
    if ((sc_window_drag.offsetLeft - sc_pos1) < 0) {
      sc_window_drag.style.left = 0;
    } else if ((sc_window_drag.offsetLeft - sc_pos1) > (window.innerWidth - sc_window_drag.style.width.split("px")[0])){
      sc_window_drag.style.left = (window.innerWidth - sc_window_drag.style.width.split("px")[0]) + "px";
    }
  }
  
  function sc_CloseDragElement() {
    for (sc_ii = 0; sc_ii < sc_windows.length; sc_ii++){
      sc_windows[sc_ii].querySelectorAll("header")[0].style.cursor = "url('imgs/cursor_grab.png'), grab";
    }
    // Stop moving
    document.onmouseup = null;
    document.onmousemove = null;
  }
}


// ---------------------------------------------------------------------
// -------------------- WINDOW & TAB OPEN AND CLOSE -------------------- 
// ---------------------------------------------------------------------
// Opens tabs on windows
function sc_OpenTab(sc_windowId, sc_className) {
  let sc_windows_current = document.getElementById(sc_windowId);
  let sc_windows_tabs = sc_windows_current.querySelectorAll("nav a");
  for (sc_iii = 0; sc_iii < sc_windows_tabs.length; sc_iii++) {
    if (sc_windows_tabs[sc_iii].classList.contains(sc_className)) {
      if (sc_windows_current.querySelectorAll("." + String(sc_windows_tabs[sc_iii].classList) + ":not(a)")[0]) {
        sc_windows_current.querySelectorAll("." + String(sc_windows_tabs[sc_iii].classList) + ":not(a)")[0].style.display = "block";
      }
      sc_windows_tabs[sc_iii].classList.add("tabActive");
      sc_windows_tabs[sc_iii].style.zIndex = sc_zIndexTracker + 1;
    } else if (String(sc_windows_tabs[sc_iii].classList)) {
      sc_windows_tabs[sc_iii].classList.remove("tabActive");
      sc_windows_tabs[sc_iii].style.zIndex = 0;
      if (sc_windows_current.querySelectorAll("." + String(sc_windows_tabs[sc_iii].classList) + ":not(a)")[0]) {
        sc_windows_current.querySelectorAll("." + String(sc_windows_tabs[sc_iii].classList) + ":not(a)")[0].style.display = "none";
      }
    }
  }
}

// Opens the window it's given
function sc_OpenWindow(sc_windowId){
  sc_windowId = document.getElementById(sc_windowId);
  
  // Place it in taskbar
  if (!document.getElementById("sc_taskbarLink_" + sc_windowId.id)){  // Only add to taskbar if not existing
    let sc_windows_taskbarLink = document.createElement('a');
    sc_windows_taskbarLink.id = "sc_taskbarLink_" + sc_windowId.id;
    if (sc_windowId.querySelectorAll("header img")[0]) {
      sc_windows_taskbarLink.style.backgroundImage = "url('" + sc_windowId.querySelectorAll("header img")[0].src + "')";
    } else {
      sc_windows_taskbarLink.style.paddingLeft = "0.5em";
    }
    sc_windows_taskbarLink.innerText = sc_windowId.querySelectorAll("header span")[0].innerText;
    sc_taskbar_linkHolder_table.insertBefore(sc_windows_taskbarLink, sc_taskbar_linkHolder_tableEmpty);
    sc_windows_taskbarLink.addEventListener("click", function() {
        sc_MinimiseToggle(this.id.split("sc_taskbarLink_")[1])
      });
  }
  
  // Reset window to appear on top and be the right size
  sc_windowId.style.top = "calc(50% - 250px)";
  sc_windowId.style.left = "calc(50% - 200px)";
  sc_windowId.style.width = "400px";
  sc_windowId.style.height = "500px";
  sc_windowId.style.display = "block";
  sc_windowId.focus();
  sc_ZIndexFix(sc_windowId.id);
}

// Closes the window it's given
function sc_CloseWindow(sc_windowId){
  document.getElementById(sc_windowId).style.display = "none";
  if (document.getElementById(sc_windowId).querySelectorAll("nav a:nth-child(2)")[0]) {
    sc_OpenTab(sc_windowId, document.getElementById(sc_windowId).querySelectorAll("nav a")[0].classList[0]);
  }
  
  // Remove it from the taskbar
  sc_taskbar_linkHolder_table.removeChild(document.getElementById("sc_taskbarLink_" + sc_windowId));
}


// ----------------------------------------------------------------------
// ----------------- WINDOW OPEN AND CLOSE FROM TASKBAR ----------------- 
// ----------------------------------------------------------------------
function sc_MinimiseToggle(sc_windowId) {
  sc_windowId = document.getElementById(sc_windowId);
  
  if (document.getElementById("sc_taskbarLink_" + sc_windowId.id)) {  // If taskbar button exists
    if (sc_windowId.style.display == "none") {
      sc_windowId.style.display = "block";
      sc_ZIndexFix(sc_windowId.id);
      sc_windowId.focus();
    } else if (sc_windowId.style.zIndex == sc_zIndexTracker) { // If window's on top, hide it
      sc_windowId.style.display = "none";
    } else {  // If window's not on top, make it on top
      sc_ZIndexFix(sc_windowId.id);
      sc_windowId.focus();
    }
  } else {
    sc_OpenWindow(sc_windowId.id);  // If taskbar button not existing, open the window
  }
}


// ---------------------------------------------------------------------
// --------------------------- TASKBAR CLOCK --------------------------- 
// ---------------------------------------------------------------------
if (sc_setting_clockActive) {
  const sc_clockElement = document.createElement("div");
  sc_clockElement.id = "sc_taskbar_time";
  sc_taskbar.appendChild(sc_clockElement);
  
  function sc_ClockChange() {
    var sc_timeSuffix = " AM";
    var sc_date = new Date();
    var sc_sec = sc_date.getSeconds();
    var sc_min = sc_date.getMinutes();
    var sc_hour = sc_date.getHours();
    if (sc_hour >= 12) {
      sc_timeSuffix = " PM";
    }
    if (sc_hour > 12) {
      sc_hour -= 12;
    } else if (sc_hour == 0) {
      sc_hour = 12;
    }
    sc_clockElement.innerText = 
      ("0" + sc_hour).substr(-2) + ":" + ("0" + sc_min).substr(-2) + sc_timeSuffix;
  }
  
  setInterval(sc_ClockChange, 1000);
}